#version 150

in vec4 vertexPosition;
in vec3 vertexNormal;
in vec4 vertexColor;
in vec2 vertexTexCoords;
uniform int framebufferHeight;
uniform int framebufferWidth;
uniform int shaderModeSwitch;
uniform mat4 modelViewProjectionMatrix;
uniform vec4 randomNumber;
uniform float time;

flat out vec4 varaColor;

out vec4 transformFeedbackTextcoord;
out vec4 transformFeedbackColor;
out vec3 transformFeedbackNormal;
out vec4 transformFeedbackPosition;

void main(void) {
    if(shaderModeSwitch==1) {
        vec4 position = modelViewProjectionMatrix * vertexPosition;
        gl_Position = position;
        float size = ((framebufferWidth+framebufferHeight)*0.1)/position.z;
//         float size = 150/position.z;
        float alpha = 1;
        if(size < 6)
            alpha = ((size-2)/4.);

        if(size <= 2)
            alpha = 0;

        varaColor = vec4(vertexColor.rgb, alpha*vertexColor.a);


        gl_PointSize = size;
    }
    else {

        vec3 direction = vertexNormal;
        float directionChangeCountDown = vertexTexCoords.x-time;
        if(directionChangeCountDown<0) {
            directionChangeCountDown = randomNumber.w*10;
            direction = randomNumber.xyz*2-vec3(1);
        }


        vec3 newPosition = vec3(vertexPosition)+direction*time*0.5;
        if(newPosition.x>100) newPosition.x=-100;
        if(newPosition.y>100) newPosition.y=-100;
        if(newPosition.z>100) newPosition.z=-100;
        if(newPosition.x<-100) newPosition.x=100;
        if(newPosition.y<-100) newPosition.y=100;
        if(newPosition.z<-100) newPosition.z=100;

        transformFeedbackColor = vertexColor;
        transformFeedbackNormal = direction;
        transformFeedbackTextcoord = vec4(directionChangeCountDown, vertexTexCoords.y, 0, 0);
        transformFeedbackPosition = vec4(newPosition, 1);
    }
}