#version 150

in vec4 varaPosition;
in vec3 varaNormal;
in vec3 varaColor;
in vec3 varaLightDirections[4];
in float varaLightIntensity[4];
in vec2 varaTexCoords;
smooth in vec3 varaEnvMapTexCoords;

uniform vec3 cameraPosition;
//uniform mat3 normalMatrix;

uniform vec3 diffuseLightColors[4];
uniform vec3 ambientLightColors[4];
uniform vec3 specularLightColors[4];
uniform sampler2D colorMap0;
uniform samplerCube cubeMap;

//uniform int lightCount
//uniform vec3 lightPositions[4];

//uniform vec3 lightAttenuationConstants[4];

out vec4 vFragColor;

void main(void) {



	//materialADSReflectivity ... vector containing the material reflectivity parameters
	vec3 materialADSReflectivity = vec3(0.2, 0.9, 0.99);
	vec3 total= vec3(0.0, 0.0, 0.0);

	for(int i = 0; i < 4; i++){

		if(varaLightIntensity[i] != 0){

			float diffuseFactor = max(0.0, dot(normalize(varaNormal),normalize(varaLightDirections[i])));

			vec3 diffusePart = diffuseLightColors[i] * diffuseFactor * materialADSReflectivity.y* varaLightIntensity[i];
			vec3 ambientPart = ambientLightColors[i] * materialADSReflectivity.x;


			total +=(ambientPart+ diffusePart);

			//specular part calculation

			vec3 h = normalize(normalize(cameraPosition-varaPosition.xyz) + normalize(varaLightDirections[i]));
			float spec = max(0.0, dot(normalize(varaNormal), h));
			float spec2 = diffuseFactor * materialADSReflectivity.z * varaLightIntensity[i];
			if(spec2 > 0){
				float fSpec = spec2 * pow(spec,64.0);
				//total += vec3(fSpec, fSpec, fSpec);
				total += fSpec * specularLightColors[i];
			}
		}
	}
	total += texture(cubeMap, varaEnvMapTexCoords).rgb;
	total *= texture(colorMap0, varaTexCoords).rgb;
//     total = varaEnvMapTexCoords;
	vFragColor = vec4(total, 0.0);
}