#version 150

in vec4 vertexPosition;
in vec3 vertexColor;
in vec3 vertexNormal;
in vec2 vertexTexCoords;

uniform mat4 modelMatrix;
uniform mat4 modelViewProjectionMatrix;
uniform mat3 normalMatrix;
uniform mat4 viewMatrix;


uniform vec3 lightPositions[4];
uniform vec3 lightAttenuationConstants[4];
uniform vec3 cameraPosition;

out vec3 varaColor;
out vec3 varaNormal;
out vec4 varaPosition;
out vec3 varaLightDirections[4];
out float varaLightIntensity[4];
out vec2 varaTexCoords;
smooth out vec3 varaEnvMapTexCoords;


void main(void) {

	//varaNormal = normalMatrix * vertexNormal;
	vec3 vNormal = normalize(normalMatrix * vertexNormal);
	varaNormal = vNormal;
	varaColor = vertexColor;
	varaTexCoords=vertexTexCoords;
	//calculate vertex position in world space
	//vec4 varaPosition = modelMatrix * vertexPosition;
	vec4 pos1 = modelMatrix * vertexPosition;
	varaPosition = pos1;
	vec3 pos = pos1.xyz/pos1.w;

	for (int i =0; i<4 ; i++){
		vec3 dir = lightPositions[i]-pos;
		varaLightDirections[i] = normalize(dir);
		float distance = length(dir);
		if(!(lightAttenuationConstants[i].x == 0.0))
		varaLightIntensity[i] = 1.0/(lightAttenuationConstants[i].x + lightAttenuationConstants[i].y * distance + lightAttenuationConstants[i].z * distance * distance);
	}
	vec4 vCoords = vec4(reflect(normalize(pos-cameraPosition),vNormal), 1.0);
	//vCoords = inverse(viewMatrix) * vCoords;
	varaEnvMapTexCoords = vCoords.xyz;
//     varaEnvMapTexCoords = pos/200.+vec3(0.5);

	gl_Position = modelViewProjectionMatrix * vertexPosition;
}